EmailManager.Web/Controllers/ClosedEmailsController.cs
using EmailManager.Data.Models;
using EmailManager.Services.Contracts;
using EmailManager.Web.Mappers.Contracts;
using EmailManager.Web.Models;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Linq;
using System.Threading.Tasks;

namespace EmailManager.Web.Controllers
{
    public class ClosedEmailsController : Controller
    {

        private readonly IEmailService emailService;
        private readonly IViewModelMapper<ClientEmail, EmailViewModel> emailMapper;

        public ClosedEmailsController(IEmailService emailService, IViewModelMapper<ClientEmail, EmailViewModel> emailMapper)
        {
            this.emailService = emailService ?? throw new ArgumentNullException(nameof(emailService));
            this.emailMapper = emailMapper ?? throw new ArgumentNullException(nameof(emailMapper));
        }

        [HttpGet]

        public IActionResult ClosedApplication()
        {
            return View();
        }

        [HttpPost]
        public async Task<IActionResult> ListClosedEmails()
        {
            var draw = Request.Form["draw"].FirstOrDefault();
            var start = Request.Form["start"].FirstOrDefault();
            var length = Request.Form["length"].FirstOrDefault();
            var searchValue = Request.Form["search[value]"].FirstOrDefault();

            int pageSize = length != null ? Convert.ToInt32(length) : 0;
            int skip = start != null ? Convert.ToInt32(start) : 0;

            int totalRecord = this.emailService.GetClosedEmailsCount();
            var emails = await this.emailService.ListClosedEmails(skip, pageSize, searchValue);

            var model = emails.Select(x => this.emailMapper.MapFrom(x)).ToList();

            var json = Json(new { draw = draw, recordsFiltered = totalRecord, recordsTotal = totalRecord, data = model });

            json.SerializerSettings = new Newtonsoft.Json.JsonSerializerSettings
            {
                ReferenceLoopHandling = Newtonsoft.Json.ReferenceLoopHandling.Ignore
            };

            return json;
        }

        [HttpGet]
        public IActionResult Details(int Id)
        {
            var email = this.emailService.GetEmail(Id);
            var model = this.emailMapper.MapFrom(email);
            return PartialView("_ClosedApplication", model);
        }

    }
}

EmailManager.Web/Controllers/EmailController.cs
using EmailManager.Data.Models;
using EmailManager.Services.Contracts;
using EmailManager.Services.Enums;
using EmailManager.Web.Data;
using EmailManager.Web.Mappers.Contracts;
using EmailManager.Web.Models;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace EmailManager.Web.Controllers
{
    public class EmailController : Controller
    {
        private readonly IEmailService emailService;
        private readonly IViewModelMapper<ClientEmail, EmailViewModel> emailMapper;
        private readonly IViewModelMapper<IReadOnlyCollection<ClientEmail>, EmailsViewModel> emailsMapper;
        private readonly UserManager<ApplicationUser> _userManager;

        public EmailController(IEmailService emailService, IViewModelMapper<ClientEmail, EmailViewModel> emailMapper, 
            IViewModelMapper<IReadOnlyCollection<ClientEmail>, EmailsViewModel> emailsMapper, 
            UserManager<ApplicationUser> userManager)
        {
            this.emailService = emailService ?? throw new ArgumentNullException(nameof(emailService));
            this.emailMapper = emailMapper ?? throw new ArgumentNullException(nameof(emailMapper));
            this.emailsMapper = emailsMapper ?? throw new ArgumentNullException(nameof(emailsMapper));
            _userManager = userManager ?? throw new ArgumentNullException(nameof(userManager));
        }

        public IActionResult Index()
        {
            return View();
        }

        [HttpPost]
        public async Task<IActionResult> ListAllEmails()
        {
            var draw = Request.Form["draw"].FirstOrDefault();
            var start = Request.Form["start"].FirstOrDefault();
            var length = Request.Form["length"].FirstOrDefault();
            var searchValue = Request.Form["search[value]"].FirstOrDefault();

            int pageSize = length != null ? Convert.ToInt32(length) : 0;
            int skip = start != null ? Convert.ToInt32(start) : 0;

            int totalRecord = this.emailService.GetEmailsCount();
            var emails = await this.emailService.ListAllEmails(skip, pageSize, searchValue);


            var model = emails.Select(x => this.emailMapper.MapFrom(x)).ToList();

            var json = Json(new { draw = draw, recordsFiltered = totalRecord, recordsTotal = totalRecord, data = model });

            json.SerializerSettings = new Newtonsoft.Json.JsonSerializerSettings
            {
                ReferenceLoopHandling = Newtonsoft.Json.ReferenceLoopHandling.Ignore
            };

            return json;
        }

        [HttpGet]
        public IActionResult Details(int Id)
        {
            var email = this.emailService.GetEmail(Id);
            var model = this.emailMapper.MapFrom(email);
            return PartialView("_DetailsPartial", model);
        }

        private Task<ApplicationUser> GetCurrentUserAsync() => _userManager.GetUserAsync(HttpContext.User);

        [HttpPost]
        public async Task<IActionResult> ChangeStatusToNotReviewedAsync(int emailId)
        {
            var currentUser = await GetCurrentUserAsync();
            var email = await this.emailService.ChangeStatusToNotReviewedAsync(emailId, currentUser);

            return Ok("Ok!");
        }

        [HttpPost]
        public async Task<IActionResult> ChangeStatusToNotValidAsync(int emailId)
        {
            var currentUser = await GetCurrentUserAsync();
            var email = await this.emailService.ChangeStatusToNotValidAsync(emailId, currentUser);

            return Ok("Ok!");
        }

        [HttpPost]
        public async Task<IActionResult> ChangeStatusToNewAsync(int emailId)
        {
            var currentUser = await GetCurrentUserAsync();
            var email = await this.emailService.ChangeStatusToNewAsync(emailId, currentUser);

            return Ok("Ok!");
        }

        [HttpPost]
        public async Task<IActionResult> ChangeStatusToOpenAsync(int emailId)
        {
            var currentUser = await GetCurrentUserAsync();
            var email = await this.emailService.ChangeStatusToOpenAsync(emailId, currentUser);

            return Ok("Ok!");
        }

        [HttpPost]
        public async Task<IActionResult> LoanApprovedAsync(int emailid)
        {
            var currentUser = await GetCurrentUserAsync();
            var email = await this.emailService.LoanApprovedAsync(emailid, currentUser);

            return Ok("Ok!");
        }

        [HttpPost]
        public async Task<IActionResult> LoanRejectedAsync(int emailid)
        {
            var currentUser = await GetCurrentUserAsync();
            var email = await this.emailService.LoanRejectedAsync(emailid, currentUser);

            return Ok("Ok!");
        }
    }
}

EmailManager.Web/Controllers/MerchantController.cs
using EmailManager.Data.Models;
using EmailManager.Services.Contracts;
using EmailManager.Web.Mappers.Contracts;
using EmailManager.Web.Models;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using System;
using System.Threading.Tasks;

namespace EmailManager.Web.Controllers
{
    public class MerchantController : Controller
    {
        private readonly IMerchantService merchantService;
        private readonly IViewModelMapper<Merchant, MerchantViewModel> merchantMapper;

        public MerchantController(IMerchantService merchantService, IViewModelMapper<Merchant, MerchantViewModel> merchantMapper)
        {
            this.merchantService = merchantService ?? throw new ArgumentNullException(nameof(merchantService));
            this.merchantMapper = merchantMapper ?? throw new ArgumentNullException(nameof(merchantMapper));
        }

        [HttpGet]
        [Authorize(Roles = "Manager")]
        public IActionResult AddMerchant()
        {
            return View();
        }

        [HttpPost]
        [Authorize(Roles = "Manager")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> AddMerchant(MerchantViewModel model)
        {
            if (!this.ModelState.IsValid)
            {
                return View(model);
            }

            var merchant = await this.merchantService.AddMerchantAsync(model.Name, model.PersonalEmail);

            return RedirectToAction("Index", "Home");
        }
    }
}

EmailManager.Web/Controllers/OpenEmailsController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using EmailManager.Data.Models;
using EmailManager.Services.Contracts;
using EmailManager.Web.Mappers.Contracts;
using EmailManager.Web.Models;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;

namespace EmailManager.Web.Controllers
{
    public class OpenEmailsController : Controller
    {

        private readonly IEmailService emailService;
        private readonly IViewModelMapper<ClientEmail, EmailViewModel> emailMapper;

        public OpenEmailsController(IEmailService emailService, IViewModelMapper<ClientEmail, EmailViewModel> emailMapper)
        {
            this.emailService = emailService ?? throw new ArgumentNullException(nameof(emailService));
            this.emailMapper = emailMapper ?? throw new ArgumentNullException(nameof(emailMapper));
        }

        [HttpGet]
        public IActionResult Details(int Id)
        {
            var email = this.emailService.GetEmail(Id);
            var model = this.emailMapper.MapFrom(email);
            return PartialView("_OpenApplication", model);
        }

        [HttpGet]

        public IActionResult OpenApplication()
        {
            return View();
        }

        [HttpPost]
        public async Task<IActionResult> ListOpenEmails()
        {
            var draw = Request.Form["draw"].FirstOrDefault();
            var start = Request.Form["start"].FirstOrDefault();
            var length = Request.Form["length"].FirstOrDefault();
            var searchValue = Request.Form["search[value]"].FirstOrDefault();

            int pageSize = length != null ? Convert.ToInt32(length) : 0;
            int skip = start != null ? Convert.ToInt32(start) : 0;

            int totalRecord = this.emailService.GetOpenEmailsCount();
            var emails = await this.emailService.ListOpenEmails(skip, pageSize, searchValue);
            
            var model = emails.Select(x => this.emailMapper.MapFrom(x)).ToList();

            var json = Json(new { draw = draw, recordsFiltered = totalRecord, recordsTotal = totalRecord, data = model });

            json.SerializerSettings = new Newtonsoft.Json.JsonSerializerSettings
            {
                ReferenceLoopHandling = Newtonsoft.Json.ReferenceLoopHandling.Ignore
            };

            return json;
        }
    }
}

EmailManager.Web/Views/Shared/_AddLoanApplication.cshtml
@model EmailApplicationViewModel

<div class="content-wrapper">
    <textarea readonly style="background-color:ivory;">@if (Model.Email.EmailBodyContent != null)
        {
            @Html.Raw(@Model.Email.EmailBodyContent)
        }
    </textarea>

    @{ var loanApplication = Model.LoanApplication;}

    <form id="add-loanapllication-form" asp-controller="LoanApplication" asp-action="Details" method="post">
        <div class="col-md-6">
            <div class="form-group">
                <p></p><br />
                <label asp-for="@loanApplication.LoanApplicant.Name">Applicant Name</label>
                <input placeholder="Name" asp-for="@loanApplication.LoanApplicant.Name" name ="LoanApplicant.Name" class="form-control" />
                <span asp-validation-for="@loanApplication.LoanApplicant.Name" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="@loanApplication.LoanApplicant.PersonalNumber">Personal number</label>
                <input placeholder="Personal Number" asp-for="@loanApplication.LoanApplicant.PersonalNumber" name="LoanApplicant.PersonalNumber" class="form-control" />
                <span asp-validation-for="@loanApplication.LoanApplicant.PersonalNumber" class="text-danger"></span>
            </div>
            <div class="form-group">
                <label asp-for="@loanApplication.LoanApplicant.PhoneNumber">Phone number</label>
                <input placeholder="+359 xxx xxx xxx" asp-for="@loanApplication.LoanApplicant.PhoneNumber" name="LoanApplicant.PhoneNumber" class="form-control" />
                <span asp-validation-for="@loanApplication.LoanApplicant.PhoneNumber" class="text-danger"></span>
            </div>
            <div class="row">
                <div class="col-md-3">
                    <div class="form-group">
                        <button type="button" class="btn btn-success" id="Open" data-dismiss="modal">Open</button>
                    </div>
                </div>
                <div class="col-md-3">
                    @if (User.IsInRole("Manager"))
                    {
                        <button type="submit" class="btn btn-success" id="NotReviewed" data-dismiss="modal">Not Reviewed</button>
                    }
                </div>

            </div>
        </div>
    </form>
</div>


<style>
    .content-wrapper textarea {
        width: 100%;
        height: calc(100vh - 320px);
        resize: none;
    }
</style>

<script>
    $(function () {
        $('#NotReviewed').click(function (e) {
            e.preventDefault();
            var id = $(this).data('emailId');

            $.post("/Email/ChangeStatusToNotReviewedAsync/", { emailId: id }, function (response) {
                console.log(response);
            });
        });
    });
</script>

EmailManager.Web/Views/Shared/_ClosedApplication.cshtml
@model EmailViewModel

<div class="content-wrapper">
    <textarea readonly style="background-color:ivory;">@if (Model.EmailBodyContent != null)
        {
            @Html.Raw(@Model.EmailBodyContent)
        }
    </textarea>

    @if (Model.Attachments.Count > 0)

    {
        foreach (var attachment in Model.Attachments)
        {
            <div><img src="/images/paperclip-vector-paper-clamp-3.png" style="width:18px" />: @attachment.FileName, Size: @attachment.Size bytes</div>
        }
    }

    @if (User.IsInRole("Manager"))
        {
            <button type="submit" class="btn btn-success" id="New" data-dismiss="modal">New</button>
        }
    
</div>


<style>
    .content-wrapper textarea {
        width: 100%;
        height: calc(100vh - 320px);
        resize: none;
    }
</style>


<script>
    $(function () {
        $('#New').click(function (e) {
            e.preventDefault();
            var id = $(this).data('emailid');

            $.post("/Email/ChangeStatusToNewAsync/", { emailId: id }, function (response) {
                console.log(response);
            });
        });
    });
</script>

EmailManager.Web/Views/Shared/_DetailsPartial.cshtml
@model EmailViewModel


<div class="content-wrapper">
    <textarea readonly style="background-color:ivory;">@if (Model.EmailBodyContent != null)
        {
            @Html.Raw(@Model.EmailBodyContent)
        }
    </textarea>

    @if (Model.Attachments.Count > 0)
    {
        foreach (var attachment in Model.Attachments)
        {
            <div><img src="/images/paperclip-vector-paper-clamp-3.png" style="width:18px" />: @attachment.FileName, Size: @attachment.Size bytes</div>
        }
    }

    @if (Model.EmailStatusType == "NotReviewed")
    {
        <button type="button" class="btn btn-success" id="New" data-dismiss="modal">New</button>
        <button type="submit" class="btn btn-success" id="NotValid" data-dismiss="modal">Not Valid</button>

    }

    @if (Model.EmailStatusType == "NotValid" && User.IsInRole("Manager"))
    {
        <button type="submit" class="btn btn-success" id="NotReviewed" data-dismiss="modal">Not Reviewed</button>
    }

    @if (Model.EmailStatusType == "New")
    {

        if (User.IsInRole("Manager"))
        {
            <button type="submit" class="btn btn-success" id="NotReviewed" data-dismiss="modal">NotReviewed</button>
        }

        <button type="submit" class="btn btn-success" id="Open" data-dismiss="modal">Open</button>
    }

    @if (Model.EmailStatusType == "Open")
    {
        if (User.IsInRole("Manager"))
        {
            <button type="submit" class="btn btn-success" id="New" data-dismiss="modal">New</button>
        }

        <button type="submit" class="btn btn-success" id="Closed" data-dismiss="modal">Closed</button>
    }

    @if (Model.EmailStatusType == "Closed" && User.IsInRole("Manager"))
    {
        <button type="submit" class="btn btn-success" id="New" data-dismiss="modal">New</button>
    }
</div>


<style>
    .content-wrapper textarea {
        width: 100%;
        height: calc(100vh - 320px);
        resize: none;
    }
</style>

<script>
    $(function () {
        $('#NotReviewed').click(function (e) {
            e.preventDefault();
            var id = $(this).data('emailId');

            $.post("/Email/ChangeStatusToNotReviewedAsync/", { emailId: id }, function (response) {
                console.log(response);
            });
        });
    });
</script>

<script>
    $(function () {
        $('#NotValid').click(function (e) {
            e.preventDefault();
            var id = $(this).data('emailId');

            $.post("/Email/ChangeStatusToNotValidAsync/", { emailId: id }, function (response) {
                console.log(response);
            });
        });
    });
</script>

<script>
    $(function () {
        $('#New').click(function (e) {
            e.preventDefault();
            var id = $(this).data('emailId');

            $.post("/Email/ChangeStatusToNewAsync/", { emailId: id }, function (response) {
                console.log(response);
            });
        });
    });
</script>


<script>
    $(function () {
        $('#Open').click(function (e) {
            e.preventDefault();
            var id = $(this).data('emailId');

            $.post("/Email/ChangeStatusToOpenAsync/", { emailId: id }, function (response) {
                console.log(response);
            });
        });
    });
</script>

<script>
    $(function () {
        $('#Closed').click(function (e) {
            e.preventDefault();
            var id = $(this).data('emailId');

            $.post("/Email/ChangeStatusToClosedAsync/", { emailId: id }, function (response) {
                console.log(response);
            });
        });
    });
</script>

EmailManager.Web/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - EmailManager.Web</title>

    <environment include="Development">
        <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.css" />
        <link rel="stylesheet" href="~/css/site.css" />
    </environment>
    <environment exclude="Development">
        <link rel="stylesheet" href="https://ajax.aspnetcdn.com/ajax/bootstrap/3.3.7/css/bootstrap.min.css"
              asp-fallback-href="~/lib/bootstrap/dist/css/bootstrap.min.css"
              asp-fallback-test-class="sr-only" asp-fallback-test-property="position" asp-fallback-test-value="absolute" />
        <link rel="stylesheet" href="~/css/site.min.css" asp-append-version="true" />
    </environment>
    <meta name="google-site-verification" content="9kxVsAM9QPefUl_ZsFcBGKtgTqm6h0SASCrPjKN4fTQ" />
</head>
<body>
    <nav class="navbar navbar-inverse navbar-fixed-top">
        <div class="container">
            <div class="navbar-header">
                <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                    <span class="sr-only">Toggle navigation</span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                </button>
            </div>
            <div class="navbar-collapse collapse">
                <ul class="nav navbar-nav">
                    <li><a asp-area="" asp-controller="Email" asp-action="Index">Emails</a></li>
                    <li><a asp-area="" asp-controller="LoanApplication" asp-action="AddLoanApplication">New</a></li>
                    <li><a asp-area="" asp-controller="OpenEmails" asp-action="OpenApplication">Open</a></li>
                    <li><a asp-area="" asp-controller="ClosedEmails" asp-action="ClosedApplication">Closed</a></li>
                    @if (User.IsInRole("Manager"))
                    {
                        <li><a asp-area="" asp-controller="Merchant" asp-action="AddMerchant">Add Merchant</a></li>
                    }
               </ul>
                @await Html.PartialAsync("_LoginPartial")
            </div>
        </div>
    </nav>
    <div class="container body-content">
        @RenderBody()
    </div>

    <environment include="Development">
        <script src="~/lib/jquery/dist/jquery.js"></script>
        <script src="~/lib/bootstrap/dist/js/bootstrap.js"></script>
        <script src="~/js/site.js" asp-append-version="true"></script>
    </environment>
    <environment exclude="Development">
        <script src="https://ajax.aspnetcdn.com/ajax/jquery/jquery-2.2.0.min.js"
                asp-fallback-src="~/lib/jquery/dist/jquery.min.js"
                asp-fallback-test="window.jQuery"
                crossorigin="anonymous"
                integrity="sha384-K+ctZQ+LL8q6tP7I94W+qzQsfRV2a+AfHIi9k8z8l9ggpc8X+Ytst4yBo/hH+8Fk">
        </script>
        <script src="https://ajax.aspnetcdn.com/ajax/bootstrap/3.3.7/bootstrap.min.js"
                asp-fallback-src="~/lib/bootstrap/dist/js/bootstrap.min.js"
                asp-fallback-test="window.jQuery && window.jQuery.fn && window.jQuery.fn.modal"
                crossorigin="anonymous"
                integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa">
        </script>
        <script src="~/js/site.min.js" asp-append-version="true"></script>
    </environment>

    @RenderSection("Scripts", required: false)
</body>
</html>

EmailManager.Web/Views/Shared/_OpenApplication.cshtml
@model EmailViewModel

<div class="content-wrapper">
    <textarea readonly style="background-color:ivory;">@if (Model.EmailBodyContent != null)
        {
            @Html.Raw(@Model.EmailBodyContent)
        }
    </textarea>

    @if (Model.Attachments.Count > 0)

    {
        foreach (var attachment in Model.Attachments)
        {
            <div><img src="/images/paperclip-vector-paper-clamp-3.png" style="width:18px" />: @attachment.FileName, Size: @attachment.Size bytes</div>
        }
    }

    @if (Model.EmailStatusType == "Open")
    {
        if (User.IsInRole("Manager"))
        {
            <button type="submit" class="btn btn-success" id="New" data-dismiss="modal">New</button>
        }

        <button type="submit" class="btn btn-success" id="Approved" data-dismiss="modal">Approved</button>
        <button type="submit" class="btn btn-success" id="Rejected" data-dismiss="modal">Rejected</button>
    }

</div>


<style>
    .content-wrapper textarea {
        width: 100%;
        height: calc(100vh - 320px);
        resize: none;
    }
</style>


<script>
    $(function () {
        $('#New').click(function (e) {
            e.preventDefault();
            var id = $(this).data('emailid');

            $.post("/Email/ChangeStatusToNewAsync/", { emailId: id }, function (response) {
                console.log(response);
            });
        });
    });
</script>

<script>
    $(function () {
        $('#Approved').click(function (e) {
            e.preventDefault();
            var id = $(this).data('emailid');

            $.post("/Email/LoanApprovedAsync/", { emailId: id }, function (response) {
                console.log(response);
            });
        });
    });$(function () {
        $('#Rejected').click(function (e) {
            e.preventDefault();
            var id = $(this).data('emailid');

            $.post("/Email/LoanRejectedAsync/", { emailId: id }, function (response) {
                console.log(response);
            });
        });
    });
</script>